import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsMpField, CmsMpFieldParam } from './model';


/**
 * 分页查询小程序配置
 */
export async function pageCmsMpField(params: CmsMpFieldParam) {
  const res = await request.get<ApiResult<PageResult<CmsMpField>>>(
    '/cms/cms-mp-field/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询小程序配置列表
 */
export async function listCmsMpField(params?: CmsMpFieldParam) {
  const res = await request.get<ApiResult<CmsMpField[]>>(
    '/cms/cms-mp-field',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加小程序配置
 */
export async function addCmsMpField(data: CmsMpField) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-mp-field',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改小程序配置
 */
export async function updateCmsMpField(data: CmsMpField) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-mp-field',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除小程序配置
 */
export async function removeCmsMpField(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-mp-field/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除小程序配置
 */
export async function removeBatchCmsMpField(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-mp-field/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询小程序配置
 */
export async function getCmsMpField(id: number) {
  const res = await request.get<ApiResult<CmsMpField>>(
    '/cms/cms-mp-field/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
